package blatt3;

import java.io.IOException;
import java.net.SocketException;

/**
 * Serverprogramm, das die Daten des Servers versendet. Diese Klasse darf nicht
 * veraendert werden.
 * 
 */
public final class DataProvider extends Thread {

    private final AServer server;
    private int           number;
    private final int     amount;

    /**
     * Konstruktor.
     * 
     * @param amount
     *            Anzahl der maximal an jeden Client zu versendenden
     *            Nachrichten.
     * @throws IOException
     */
    public DataProvider(int amount) throws IOException {
        server = new Server(2096);
        number = 0;
        this.amount = amount;
    }

    /**
     * Generiert und sendet die Nachrichten an die Clients.
     */
    @Override
    public void run() {
        int counter = 0;
        while (counter < amount) {
            System.out.println("Sleeping");
            Util.sleep(1);
            System.out.println("Sending");
            for (int x = 0; x < server.connectionCount(); x++) {
                if (server.isConnected(x)) {
                    System.out.println("  to client " + x + ": " + number);
                    try {
                        server.sendMessage(x, "" + number);
                    } catch (SocketException se) {
                        server.disconnect(x);
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                    number++;
                }
            }
            counter++;
        }
        System.out.println("Disconnecting");
        server.disconnect();
        System.out.println("Finished");
    }
}