package blatt3;

import java.io.IOException;

/**
 * Interface fuer den Client. Diese Datei darf nicht veraendert werden.
 * 
 */
public interface IClient {

    /**
     * Verbindet sich mit einem Server.
     * 
     * @param server
     *            Adresse des Servers
     * @param port
     *            Port des Servers
     * @throws IOException
     */
    public void connect(String server, int port) throws IOException;

    /**
     * Wartet auf und empfaengt eine Nachricht.
     * 
     * @return Empfangene Nachricht
     * @throws IOException
     */
    public String receiveMessage() throws IOException;

    /**
     * Sendet eine Nachricht message an Server.
     * 
     * @param message
     *            Zu sendende Nachricht
     * @throws IOException
     */
    public void sendMessage(String message) throws IOException;

    /**
     * Beendet die Verbindung zum Server, sofern eine besteht.
     * @throws IOException
     */
    public void disconnect() throws IOException;

    /**
     * Gibt den Verbindungsstatus wieder. Liefert true nachdem connect
     * aufgerufen wurde und false wenn disconnect aufgerufen wurde.
     * 
     * @return Verbindungsstatus
     */
    public boolean isConnected();

    /**
     * Liefert die ID des Clients.
     * 
     * @return ID des Clients
     */
    public String getID();
}